package kernel.http;

using tink.CoreApi;

/**
	Wrapper for the native HTTP request function.
**/
class Http {
	public static function request(url:String,?body:String,?options: String):Future<Outcome<HTTPResponse,HTTPFailure>> {
		return new Future<Outcome<HTTPResponse,HTTPFailure>>((resolve) -> {
			KernelEvents.instance.onHttpFailure.handle((params)->{
				if (params.url == url){
					resolve(Failure(new HTTPFailure(params.failReason,params.handle)));
				}
			});

			KernelEvents.instance.onHttpSuccess.handle((params) -> {
				if (params.url == url){
					resolve(Success(new HTTPResponse(params.handle)));
				}
			});

			cc.HTTP.request(url,body);

			return null;
		});
	}
}
